    // A class to maintain monthly rainfall values for one year.
class YearlyRainfall {
    // Define public names for the months.
    public static final int Jan = 0, Feb = 1, Mar = 2, Apr = 3,
                            May = 4, Jun = 5, Jul = 6, Aug = 7,
                            Sep = 8, Oct = 9, Nov = 10, Dec = 11;
    public static final int numMonths = 12;

    public YearlyRainfall(){
        // Create the array to hold the data.
        int[] rainfall = new int[numMonths];
        setRainfall(rainfall);

        // Set up the labels for the display.
        // Labels for the bar chart.
        String[] labels = new String[numMonths];
        labels[Jan] = "Jan";
        labels[Feb] = "Feb";
        labels[Mar] = "Mar";
        labels[Apr] = "Apr";
        labels[May] = "May";
        labels[Jun] = "Jun";
        labels[Jul] = "Jul";
        labels[Aug] = "Aug";
        labels[Sep] = "Sep";
        labels[Oct] = "Oct";
        labels[Nov] = "Nov";
        labels[Dec] = "Dec";
        RainfallDisplay display = getDisplay();
        display.setBarLabels(labels);
    }

        // Return the rainfall for the given month, or -1 if
        // the month is illegal.
    public int getMonthAmount(int month){
        if((month >= Jan) && (month <= Dec)){
            int[] rain = getRainfall();
            return rain[month];
        }
        else{
            return -1;
        }
    }

        // Set the rainfall for the given month.
        // Make sure the display is updated to reflect the change.
        // Do nothing if the month is illegal.
    public void setMonthAmount(int month,int amount){
        if((month >= Jan) && (month <= Dec)){
            int[] rain = getRainfall();
            rain[month] = amount;
            // Update the display.
            RainfallDisplay display = getDisplay();
            display.repaint();
        }
    }

        // Return the mean monthly rainfall.
    public double getMean(){
        int[] rain = getRainfall();
        // Accumulate the total rainfall.
        double totalRain = 0.0;
        int month = Jan;
        while(month <= Dec){
            totalRain += rain[month];
            month++;
        }
        return totalRain / numMonths;
    }

    private int[] getRainfall(){
        return rainfall;
    }

    private void setRainfall(int[] r){
        if(r != null){
            rainfall = r;
            // Make sure the display has a copy of the
            // data to be displayed.
            RainfallDisplay display = getDisplay();
            display.setData(rainfall);
        }
    }

        // An accessor for the rainfall display.
    private RainfallDisplay getDisplay(){
        return display;
    }

    // The monthly rainfall values - initialized in the constructor.
    private int[] rainfall;
    // An (optional) display for the rainfall data.
    private RainfallDisplay display = new RainfallDisplay();
}
