import java.util.ArrayList;

        // Create a suited pack of cards, on construction, and
        // shuffle them.
        // Provide successive cards via the nextCard method.
class Pack {
    public Pack(int cardsPerSuit){
        ArrayList pack = getPack();
        // Construct a pack of cards, 4 copies of values 1..cardsPerSuit.
        final int numSuits = 4;
        for(int suit = 0; suit < numSuits; suit++){
            for(int value = 1; value <= cardsPerSuit; value++){
                pack.add(new SuitedCard(suit,value));
            }
        }
        shuffle();
    }

        // Return the card on the top of the pack, or null
        // if there are no more.
    public SuitedCard nextCard(){
        ArrayList pack = getPack();
        final int numCards = pack.size();
        if(numCards > 0){
            // Remove the last.
            return (SuitedCard) pack.remove(numCards-1);
        }
        else{
            return null;
        }
    }

    public int size(){
        return getPack().size();
    }

        // Shuffle the cards in the pack.
    private void shuffle(){
        // Repeatedly swap cards around in the pack.
        final ArrayList pack = getPack();
        final int cardsInDeck = pack.size();
        final int shuffleTimes = 10*cardsInDeck;
        for(int i = 0; i < shuffleTimes; i++){
            // Generate the indices of two cards to move.
            int first = (int) (Math.random()*cardsInDeck),
                second = (int) (Math.random()*cardsInDeck);
            Object card = pack.get(first);
            // Replace the second with the first ...
            card = pack.set(second,card);
            // ... and vice versa.
            pack.set(first,card);
        }
    }

    private ArrayList getPack(){
        return pack;
    }

    // The cards in the pack.
    private final ArrayList pack = new ArrayList();
}
