        // Play a card game in which the first card of a round
        // may be any card from a player's hand, but all subsequent
        // cards must follow the lead suit, if possible.
class Player {
    public Player(int id){
        // The player has an identity.
        identity = id;
    }

        // Receive a card from the dealer.
    public void takeCard(SuitedCard c){
        getHand().add(c);
    }

        // Play any card from the hand. Return null if
        // we have no more cards. We have a free choice
        // of suit.
    public SuitedCard playAnyCard(){
        if(numCards() > 0){
            // We have at least one card.
            return getHand().getNextCard();
        }
        else{
            return null;
        }
    }

        // We must follow suit, if possible.
    public SuitedCard followSuit(String suit){
        SuitedCard c = getHand().getCardInSuit(suit);
        if(c != null){
            return c;
        }
        else{
            return playAnyCard();
        }
    }

    public int getIdentity(){
        return identity;
    }

    public int numCards(){
        return getHand().numCards();
    }

    private Hand getHand(){
        return hand;
    }

    // A collection to hold the player's cards.
    private Hand hand = new Hand();
    // The player's identifying number.
    private final int identity;
}
