import java.io.*;

        // Decode data values stored via a DataEncoder.
        // Use the byte prefix of each to determine what
        // type of value is stored.
class DataDecoderMain {
    public static void main(String[] args) {
        try{
            // Where the binary data is stored.
            String filename = "data.bin";
            DataInputStream inputFile = new DataInputStream(
                                        new FileInputStream(filename));
            // Read the encoding byte;
            byte dataType = inputFile.readByte();
            while(dataType != DataEncoder.ENDOFFILE){
                switch(dataType){
                    case DataEncoder.BOOLEAN:
                        boolean b = inputFile.readBoolean();
                        System.out.println("Boolean: "+b);
                        break;
                    case DataEncoder.DOUBLE:
                        double d = inputFile.readDouble();
                        System.out.println("Double: "+d);
                        break;
                    case DataEncoder.INT:
                        int i = inputFile.readInt();
                        System.out.println("Int: "+i);
                        break;
                    case DataEncoder.STRING:
                        String s = inputFile.readUTF();
                        System.out.println("String: "+s);
                        break;
                    default:
                        throw new IOException(
                                "Unknown data type: "+dataType);
                }
                dataType = inputFile.readByte();
            }
            inputFile.close();
        }
        catch(FileNotFoundException e){
            System.err.println("File not found: "+e.getMessage());
        }
        catch(IOException e){
            System.err.println("IO exception: "+e.getMessage());
        }
    }
}
