import java.io.*;

        // Decode a message whose individual characters are
        // randomly scattered through the file: message.bin.
        // The length of the message is stored as an int at
        // offset 0 within the file. This is immediately followed
        // by the offset (from the start of the file) of the first
        // character of the message.  Thereafter, the next offset
        // follows each char in turn, up to the length of the message.
class MessageDecoder {
    public static void main(String[] args) throws IOException {
        final RandomAccessFile file =
                        new RandomAccessFile("message.bin","r");
        // Find the length of the message.
        file.seek(0L);
        final int length = file.readInt();
        StringBuffer message = new StringBuffer(length);
        for(int i = 0; i < length; i++){
            // Read the next location, and move there.
            long where = file.readLong();
            if(where < file.length()){
                file.seek(where);
                char ch = file.readChar();
                message.append(ch);
                // Print a diagnostic.
                System.out.println(ch+" @ "+where);
            }
            else{
                throw new IOException("Where ("+where+
                                      ") is outside the file: "+
                                      file.length());
            }
        }
        file.close();
        System.out.println("The message is: "+message.toString());
    }
}
