import java.io.*;

        // Number the lines of a text file. The space occupied
        // by the line number should be a fixed width of five
        // characters, padded on the left with spaces.
class NumberLines {
    public static void main(String[] args) throws IOException {
        if(args.length == 1){
            // A fixed width of five characters is to be used for
            // the line numbers. The length of prefix will be
            // gradually reduced as the line number get bigger.
            String prefix = "     ";
            // The fixed margin width.
            final int marginWidth = prefix.length();
            LineNumberReader reader = new LineNumberReader(
                                new FileReader(args[0]));
            String line = reader.readLine();
            while(line != null){
                // Format the line number.
                String lineNumber = reader.getLineNumber()+"";
                if(lineNumber.length()+prefix.length() > marginWidth){
                    // Drop one character from prefix.
                    if(prefix.length() > 0){
                        prefix = prefix.substring(1);
                    }
                }
                System.out.println(prefix+lineNumber+" "+line);
                line = reader.readLine();
            }
            reader.close();
        }
        else{
            // No file name was given.
            System.out.println("Usage: "+"java NumberLines text-file");
        }
    }
}
