import java.util.*;

        // Select those of the System properties with prefixes
        // matching the command line arguments.
        // Print lists of the keys and values obtained.
class SelectProperties2 {
    public static void main(String[] args){
        // Store the properties in a HashMap.
        HashMap selectedProperties;
        Properties systemProperties = System.getProperties();

        if(args.length > 0){
            final int numArgs = args.length;
            selectedProperties = new HashMap();
            // Find the required properties.
            Enumeration propNames = systemProperties.propertyNames();

            while(propNames.hasMoreElements()){
                // Get the property name, which is the key.
                String name = (String) propNames.nextElement();
                boolean found = false;
                for(int i = 0; i < numArgs && !found; i++){
                    if(name.startsWith(args[i])){
                        found = true;
                    }
                }
                if(found){
                    // Look up its value in the properties.
                    String value = systemProperties.getProperty(name);
                    selectedProperties.put(name,
                                    systemProperties.getProperty(name));
                }
            }
        }
        else{
            // All are required.
            selectedProperties = new HashMap(systemProperties);
        }
        // Print out what was found.
        showValues(selectedProperties);
        showKeys(selectedProperties);
    }

        // Show all of the values in the given map.
    public static void showValues(HashMap map){
        Collection values = map.values();
        Iterator it = values.iterator();
        System.out.println("Values:");
        while(it.hasNext()){
            String value = (String) it.next();
            System.out.println(value);
        }
    }

        // Show all of the keys in the given map.
    public static void showKeys(HashMap map){
        Set keys = map.keySet();
        Iterator it = keys.iterator();
        System.out.println("Keys:");
        while(it.hasNext()){
            String value = (String) it.next();
            System.out.println(value);
        }
    }
}
