        // An interface for players of the SuitedCard game.
        // Players receive notification of
        //         + Which cards have not been dealt.
        //        + Which cards are played in a round.
        //        + Who won each round.
interface CardPlayer {
    // Card received as part of the deal.
    public void takeCard(SuitedCard c);
    // Card not dealt to any player.
    public void undealtCard(SuitedCard c);

    // Request to start a round.
    public SuitedCard playAnyCard();
    // Request to play within a round.
    public SuitedCard followSuit(String suit);
    // Sight of a card played as part of the current round.
    public void viewCard(SuitedCard c);

    // Notification of who won the round just completed.
    public void roundWinner(int id);

    public int getIdentity();
    // Number of cards left in the hand.
    public int numCards();
}
