    // Provide methods for encrypting and decrypting strings.
    // The encryption method is to add a simple offset to each
    // character of a string.
    // There is no guarantee that an encrypted string will be
    // printable.
class Crypto {
    // The default encryption offset.
    public static int defaultOffset = 1;

        // Use the default offset.
    public Crypto(){
    }

    public Crypto(int offset){
        this.offset = offset;
    }

        // Use the current offset to encrypt s.
    public String encrypt(String s){
        return addOffset(s,getOffset());
    }

        // Use the negative value of current offset to decrypt s.
    public String decrypt(String s){
        return addOffset(s,-getOffset());
    }

        // Add offset to every character of string, and return
        // the resulting string.
    private String addOffset(String s,int offset){
        final int length = s.length();
        StringBuffer result = new StringBuffer(length);
        for(int i = 0; i < length; i++){
            result.append((char) (s.charAt(i)+offset));
        }
        return result.toString();
    }

    public int getOffset(){
        return offset;
    }

    public void setOffset(int o){
        offset = o;
    }

    private int offset = defaultOffset;
}
